Subject: Re: [PATCH net-next 2/2] net: enetc: count the tc-taprio window drops

From: Jakub Kicinski <[email-masked]>
Date: Wed, 11 May 2022 15:27:40 -0700

On Tue, 10 May 2022 19:36:15 +0300 Vladimir Oltean wrote:
> From: Po Liu <[email-masked]>
> 
> The enetc scheduler for IEEE 802.1Qbv has 2 options (depending on
> PTGCR[TG_DROP_DISABLE]) when we attempt to send an oversized packet
> which will never fit in its allotted time slot for its traffic class:
> either block the entire port due to head-of-line blocking, or drop the
> packet and set a bit in the writeback format of the transmit buffer
> descriptor, allowing other packets to be sent.
> 
> We obviously choose the second option in the driver, but we do not
> detect the drop condition, so from the perspective of the network stack,
> the packet is sent and no error counter is incremented.
> 
> This change checks the writeback of the TX BD when tc-taprio is enabled,
> and increments a specific ethtool statistics counter and a generic
> "tx_dropped" counter in ndo_get_stats64.

Is there no MIB attribute in the standard for such drops?

The semantics seem petty implementation-independent can we put it into
some structured ethtool stats instead?